import URI from 'urijs';
import diff from 'deep-diff';

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _construct(Parent, args, Class) {
  if (_isNativeReflectConstruct()) {
    _construct = Reflect.construct;
  } else {
    _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) _setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }

  return _construct.apply(null, arguments);
}

function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}

function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? new Map() : undefined;

  _wrapNativeSuper = function _wrapNativeSuper(Class) {
    if (Class === null || !_isNativeFunction(Class)) return Class;

    if (typeof Class !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }

    if (typeof _cache !== "undefined") {
      if (_cache.has(Class)) return _cache.get(Class);

      _cache.set(Class, Wrapper);
    }

    function Wrapper() {
      return _construct(Class, arguments, _getPrototypeOf(this).constructor);
    }

    Wrapper.prototype = Object.create(Class.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class);
  };

  return _wrapNativeSuper(Class);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();

  return function _createSuperInternal() {
    var Super = _getPrototypeOf(Derived),
        result;

    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _createForOfIteratorHelper(o, allowArrayLike) {
  var it;

  if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) {
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;

      var F = function () {};

      return {
        s: F,
        n: function () {
          if (i >= o.length) return {
            done: true
          };
          return {
            done: false,
            value: o[i++]
          };
        },
        e: function (e) {
          throw e;
        },
        f: F
      };
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var normalCompletion = true,
      didErr = false,
      err;
  return {
    s: function () {
      it = o[Symbol.iterator]();
    },
    n: function () {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    },
    e: function (e) {
      didErr = true;
      err = e;
    },
    f: function () {
      try {
        if (!normalCompletion && it.return != null) it.return();
      } finally {
        if (didErr) throw err;
      }
    }
  };
}

function _classPrivateFieldGet(receiver, privateMap) {
  var descriptor = privateMap.get(receiver);

  if (!descriptor) {
    throw new TypeError("attempted to get private field on non-instance");
  }

  if (descriptor.get) {
    return descriptor.get.call(receiver);
  }

  return descriptor.value;
}

function _classPrivateFieldSet(receiver, privateMap, value) {
  var descriptor = privateMap.get(receiver);

  if (!descriptor) {
    throw new TypeError("attempted to set private field on non-instance");
  }

  if (descriptor.set) {
    descriptor.set.call(receiver, value);
  } else {
    if (!descriptor.writable) {
      throw new TypeError("attempted to set read only private field");
    }

    descriptor.value = value;
  }

  return value;
}

/* eslint-disable max-classes-per-file, no-use-before-define */

/**
 * It's a bit tricky to extends native errors
 * @see https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Error
 */
var HttpError = /*#__PURE__*/function (_Error) {
  _inherits(HttpError, _Error);

  var _super = _createSuper(HttpError);

  function HttpError(message, baseResponse) {
    var _this;

    _classCallCheck(this, HttpError);

    _this = _super.call(this, message || 'Http errort'); // Set the prototype explicitly.

    _defineProperty(_assertThisInitialized(_this), "baseResponse", void 0);

    Object.setPrototypeOf(_assertThisInitialized(_this), OauthError.prototype); // Maintains proper stack trace for where our error was thrown (only available on V8)

    if (Error.captureStackTrace) {
      Error.captureStackTrace(_assertThisInitialized(_this), OauthError);
    }

    _this.name = 'HttpError';
    _this.baseResponse = baseResponse;
    return _this;
  }
  /**
   * Get the JSON of the baseResponse directly, if possible
   */


  _createClass(HttpError, [{
    key: "responseJson",
    value: function responseJson() {
      return this.baseResponse.json();
    }
  }]);

  return HttpError;
}( /*#__PURE__*/_wrapNativeSuper(Error));

var OauthError = /*#__PURE__*/function (_Error2) {
  _inherits(OauthError, _Error2);

  var _super2 = _createSuper(OauthError);

  function OauthError(message, previousError) {
    var _this2;

    _classCallCheck(this, OauthError);

    _this2 = _super2.call(this, message || 'Oauth error'); // Set the prototype explicitly.

    _defineProperty(_assertThisInitialized(_this2), "previousError", void 0);

    Object.setPrototypeOf(_assertThisInitialized(_this2), OauthError.prototype); // Maintains proper stack trace for where our error was thrown (only available on V8)

    if (Error.captureStackTrace) {
      Error.captureStackTrace(_assertThisInitialized(_this2), OauthError);
    }

    _this2.name = 'OauthError';
    _this2.previousError = previousError;
    return _this2;
  }

  return OauthError;
}( /*#__PURE__*/_wrapNativeSuper(Error));

var InvalidGrantError = /*#__PURE__*/function (_OauthError) {
  _inherits(InvalidGrantError, _OauthError);

  var _super3 = _createSuper(InvalidGrantError);

  function InvalidGrantError(message, previousError) {
    var _this3;

    _classCallCheck(this, InvalidGrantError);

    _this3 = _super3.call(this, message || 'Invalid grant error', previousError); // Set the prototype explicitly.

    _defineProperty(_assertThisInitialized(_this3), "previousError", void 0);

    Object.setPrototypeOf(_assertThisInitialized(_this3), InvalidGrantError.prototype); // Maintains proper stack trace for where our error was thrown (only available on V8)

    if (Error.captureStackTrace) {
      Error.captureStackTrace(_assertThisInitialized(_this3), InvalidGrantError);
    }

    _this3.name = 'InvalidGrantError';
    _this3.previousError = previousError;
    return _this3;
  }

  return InvalidGrantError;
}(OauthError);

var InvalidScopeError = /*#__PURE__*/function (_OauthError2) {
  _inherits(InvalidScopeError, _OauthError2);

  var _super4 = _createSuper(InvalidScopeError);

  function InvalidScopeError(message, previousError) {
    var _this4;

    _classCallCheck(this, InvalidScopeError);

    _this4 = _super4.call(this, message || 'Invalid scope error', previousError); // Set the prototype explicitly.

    _defineProperty(_assertThisInitialized(_this4), "previousError", void 0);

    Object.setPrototypeOf(_assertThisInitialized(_this4), InvalidScopeError.prototype); // Maintains proper stack trace for where our error was thrown (only available on V8)

    if (Error.captureStackTrace) {
      Error.captureStackTrace(_assertThisInitialized(_this4), InvalidScopeError);
    }

    _this4.name = 'InvalidScopeError';
    _this4.previousError = previousError;
    return _this4;
  }

  return InvalidScopeError;
}(OauthError); // 400


var BadRequestError = /*#__PURE__*/function (_HttpError) {
  _inherits(BadRequestError, _HttpError);

  var _super5 = _createSuper(BadRequestError);

  function BadRequestError(message, baseResponse) {
    var _this5;

    _classCallCheck(this, BadRequestError);

    _this5 = _super5.call(this, message || 'Bad request', baseResponse); // Set the prototype explicitly.

    _defineProperty(_assertThisInitialized(_this5), "baseResponse", void 0);

    Object.setPrototypeOf(_assertThisInitialized(_this5), BadRequestError.prototype); // Maintains proper stack trace for where our error was thrown (only available on V8)

    if (Error.captureStackTrace) {
      Error.captureStackTrace(_assertThisInitialized(_this5), BadRequestError);
    }

    _this5.name = 'BadRequestError';
    _this5.baseResponse = baseResponse;
    return _this5;
  }

  return BadRequestError;
}(HttpError); // 401


var UnauthorizedError = /*#__PURE__*/function (_BadRequestError) {
  _inherits(UnauthorizedError, _BadRequestError);

  var _super6 = _createSuper(UnauthorizedError);

  function UnauthorizedError(message, baseResponse) {
    var _this6;

    _classCallCheck(this, UnauthorizedError);

    _this6 = _super6.call(this, message || 'Unauthorized', baseResponse); // Set the prototype explicitly.

    _defineProperty(_assertThisInitialized(_this6), "baseResponse", void 0);

    Object.setPrototypeOf(_assertThisInitialized(_this6), UnauthorizedError.prototype); // Maintains proper stack trace for where our error was thrown (only available on V8)

    if (Error.captureStackTrace) {
      Error.captureStackTrace(_assertThisInitialized(_this6), UnauthorizedError);
    }

    _this6.name = 'UnauthorizedError';
    _this6.baseResponse = baseResponse;
    return _this6;
  }

  return UnauthorizedError;
}(BadRequestError); // 403


var ForbiddenError = /*#__PURE__*/function (_BadRequestError2) {
  _inherits(ForbiddenError, _BadRequestError2);

  var _super7 = _createSuper(ForbiddenError);

  function ForbiddenError(message, baseResponse) {
    var _this7;

    _classCallCheck(this, ForbiddenError);

    _this7 = _super7.call(this, message || 'Forbidden', baseResponse); // Set the prototype explicitly.

    _defineProperty(_assertThisInitialized(_this7), "baseResponse", void 0);

    Object.setPrototypeOf(_assertThisInitialized(_this7), ForbiddenError.prototype); // Maintains proper stack trace for where our error was thrown (only available on V8)

    if (Error.captureStackTrace) {
      Error.captureStackTrace(_assertThisInitialized(_this7), ForbiddenError);
    }

    _this7.name = 'ForbiddenError';
    _this7.baseResponse = baseResponse;
    return _this7;
  }

  return ForbiddenError;
}(BadRequestError); // 404


var ResourceNotFoundError = /*#__PURE__*/function (_BadRequestError3) {
  _inherits(ResourceNotFoundError, _BadRequestError3);

  var _super8 = _createSuper(ResourceNotFoundError);

  function ResourceNotFoundError(message, baseResponse) {
    var _this8;

    _classCallCheck(this, ResourceNotFoundError);

    _this8 = _super8.call(this, message || 'Resource is not found', baseResponse); // Set the prototype explicitly.

    _defineProperty(_assertThisInitialized(_this8), "baseResponse", void 0);

    Object.setPrototypeOf(_assertThisInitialized(_this8), ResourceNotFoundError.prototype); // Maintains proper stack trace for where our error was thrown (only available on V8)

    if (Error.captureStackTrace) {
      Error.captureStackTrace(_assertThisInitialized(_this8), ResourceNotFoundError);
    }

    _this8.name = 'ResourceNotFoundError';
    _this8.baseResponse = baseResponse;
    return _this8;
  }

  return ResourceNotFoundError;
}(BadRequestError); // 409


var ConflictError = /*#__PURE__*/function (_BadRequestError4) {
  _inherits(ConflictError, _BadRequestError4);

  var _super9 = _createSuper(ConflictError);

  function ConflictError(message, baseResponse) {
    var _this9;

    _classCallCheck(this, ConflictError);

    _this9 = _super9.call(this, message || 'Conflict detected', baseResponse); // Set the prototype explicitly.

    _defineProperty(_assertThisInitialized(_this9), "baseResponse", void 0);

    Object.setPrototypeOf(_assertThisInitialized(_this9), ConflictError.prototype); // Maintains proper stack trace for where our error was thrown (only available on V8)

    if (Error.captureStackTrace) {
      Error.captureStackTrace(_assertThisInitialized(_this9), ConflictError);
    }

    _this9.name = 'ConflictError';
    _this9.baseResponse = baseResponse;
    return _this9;
  }

  return ConflictError;
}(BadRequestError); // 500


var InternalServerError = /*#__PURE__*/function (_HttpError2) {
  _inherits(InternalServerError, _HttpError2);

  var _super10 = _createSuper(InternalServerError);

  function InternalServerError(message, baseResponse) {
    var _this10;

    _classCallCheck(this, InternalServerError);

    _this10 = _super10.call(this, message || 'Internal server error', baseResponse); // Set the prototype explicitly.

    _defineProperty(_assertThisInitialized(_this10), "baseResponse", void 0);

    Object.setPrototypeOf(_assertThisInitialized(_this10), InternalServerError.prototype); // Maintains proper stack trace for where our error was thrown (only available on V8)

    if (Error.captureStackTrace) {
      Error.captureStackTrace(_assertThisInitialized(_this10), InternalServerError);
    }

    _this10.name = 'InternalServerError';
    _this10.baseResponse = baseResponse;
    return _this10;
  }

  return InternalServerError;
}(HttpError);
/**
 * @returns {HttpError}
 */


function getHttpErrorFromResponse(originalResponse) {
  var response = originalResponse.clone();

  switch (true) {
    case response.status === 401:
      return new UnauthorizedError(null, response);

    case response.status === 403:
      return new ForbiddenError(null, response);

    case response.status === 404:
      return new ResourceNotFoundError(null, response);

    case response.status === 409:
      return new ConflictError(null, response);

    case response.status >= 400 && response.status < 500:
      return new BadRequestError(null, response);

    case response.status >= 500 && response.status < 600:
      return new InternalServerError(null, response);

    default:
      return new HttpError(null, response);
  }
}

function isOauthError(body) {
  var _ref;

  return typeof ((_ref = body) === null || _ref === void 0 ? void 0 : _ref.error) === 'string';
}

var DEFAULT_CONFIG = {
  collectionKey: 'hydra:member'
};

var _config = new WeakMap();

var _classMetadataList = new WeakMap();

var Mapping = /*#__PURE__*/function () {
  function Mapping() {
    var idPrefix = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
    var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, Mapping);

    _defineProperty(this, "idPrefix", void 0);

    _config.set(this, {
      writable: true,
      value: void 0
    });

    _classMetadataList.set(this, {
      writable: true,
      value: void 0
    });

    this.idPrefix = idPrefix;

    _classPrivateFieldSet(this, _classMetadataList, []);

    this.setConfig(config);
  }

  _createClass(Mapping, [{
    key: "getConfig",
    value: function getConfig() {
      return _classPrivateFieldGet(this, _config);
    }
  }, {
    key: "setConfig",
    value: function setConfig(config) {
      _classPrivateFieldSet(this, _config, _objectSpread2(_objectSpread2({}, DEFAULT_CONFIG), config));
    }
  }, {
    key: "setMapping",
    value: function setMapping() {
      var classMetadataList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      _classPrivateFieldSet(this, _classMetadataList, classMetadataList);
    }
  }, {
    key: "getMappingKeys",
    value: function getMappingKeys() {
      return _classPrivateFieldGet(this, _classMetadataList).map(function (classMetadata) {
        return classMetadata.key;
      });
    }
  }, {
    key: "getClassMetadataByKey",
    value: function getClassMetadataByKey(key) {
      var filterList = _classPrivateFieldGet(this, _classMetadataList).filter(function (classMetadata) {
        return classMetadata.key === key;
      });

      return filterList.length > 0 ? filterList[0] : null;
    }
  }, {
    key: "isMappingValid",
    value: function isMappingValid() {
      var _this = this;

      return !_classPrivateFieldGet(this, _classMetadataList).some(function (classMetadata) {
        // check that the relations exists
        var errorList = Object.values(classMetadata.getAttributeList()).map(function (attribute) {
          var relation = classMetadata.getRelation(attribute.serializedKey);

          if (!relation) {
            // attribute can not be "invalid" (for now ?)
            return false;
          }

          var relationMetadata = _this.getClassMetadataByKey(relation.targetMetadataKey); // relation name seems weird


          if (relation.isRelationToOne() && attribute.attributeName.endsWith('List')) {
            return "\"".concat(classMetadata.key, ".").concat(attribute.serializedKey, " is defined as a MANY_TO_ONE relation, but the attribute name ends with \"List\".");
          }

          if (relation.isRelationToMany()) {
            var message = "\"".concat(classMetadata.key, ".").concat(attribute.serializedKey, " is defined as a ").concat(relation.type, " relation, but the attribute name is nor plural not ends with \"List\".");
            var endsWithList = attribute.attributeName.endsWith('List');

            try {
              // eslint-disable-next-line global-require, import/no-extraneous-dependencies, @typescript-eslint/no-var-requires
              var pluralize = require('pluralize');

              if (!endsWithList && !pluralize.isPlural(attribute.attributeName)) {
                return message;
              }
            } catch (e) {
              if (!endsWithList) {
                return "".concat(message, ".\nIf your keys does not ends with \"List\", then you should install the \"pluralize\" package.");
              }
            }
          } // no error if there is metadata linked


          if (!relationMetadata) {
            return "\"".concat(classMetadata.key, ".").concat(attribute.serializedKey, "\" defined a relation to the metadata named \"").concat(relation.targetMetadataKey, "\" but this metadata is not knowned by the mapping");
          }

          return false;
        });

        if (!classMetadata.hasIdentifierAttribute()) {
          errorList.push("\"".concat(classMetadata.key, "\" has no identifier attribute set"));
        }

        var nbError = errorList.filter(function (error) {
          if (error) {
            // eslint-disable-next-line no-console
            console.warn(error);
          }

          return error;
        });
        return nbError.length > 0;
      });
    }
  }]);

  return Mapping;
}();

var Attribute =
/**
 * @param {string} serializedKey the key returned from your API
 * @param {null|string} attributeName the name in your entity, default to the `serializedKey` attribute
 * @param {string} type type of the attribute
 * @param {boolean} isIdentifier is this attribute the entity identifier
 */
function Attribute(serializedKey) {
  var attributeName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var type = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'string';
  var isIdentifier = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;

  _classCallCheck(this, Attribute);

  _defineProperty(this, "serializedKey", void 0);

  _defineProperty(this, "attributeName", void 0);

  _defineProperty(this, "type", void 0);

  _defineProperty(this, "isIdentifier", void 0);

  if (!serializedKey) {
    throw new TypeError('`serializedKey` must not be empty');
  }

  this.serializedKey = serializedKey;
  this.attributeName = attributeName || this.serializedKey;
  this.type = type;
  this.isIdentifier = isIdentifier;
};

/* eslint-disable import/prefer-default-export */
// eslint-disable-next-line import/no-duplicates
// eslint-disable-next-line import/no-duplicates
function generateRepository(sdk, metadata) {
  var isUnitOfWorkEnabled = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  // eslint-disable-next-line new-cap
  return new metadata.repositoryClass(sdk, metadata, isUnitOfWorkEnabled);
}

/* eslint-disable consistent-return */
function removeAuthorization(headers) {
  if (!headers) {
    return;
  }

  if (headers instanceof Headers) {
    headers["delete"]('Authorization');
    return headers;
  }

  var filterAuthorization = function filterAuthorization(entries) {
    return entries.filter(function (header) {
      return header[0] !== 'Authorization';
    });
  };

  if (Array.isArray(headers)) {
    return filterAuthorization(headers);
  }

  return Object.fromEntries(filterAuthorization(Object.entries(headers)));
}
/**
 * remove undefined key, usefull to remove Content-Type for example.
 * Does not apply on "Headers" instance as values are string in there.
 */

function removeUndefinedHeaders(headers) {
  if (headers instanceof Headers) {
    return headers;
  }

  var filterEntries = function filterEntries(entries) {
    return entries.filter(function (header) {
      return header[1] !== undefined;
    });
  };

  if (Array.isArray(headers)) {
    return filterEntries(headers);
  }

  return Object.fromEntries(filterEntries(Object.entries(headers)));
}
function convertToRecord(headers) {
  if (headers instanceof Headers) {
    return Object.fromEntries(headers.entries());
  }

  if (Array.isArray(headers)) {
    return Object.fromEntries(headers);
  }

  return headers;
}

var EXPIRE_LIMIT_SECONDS = 300; // = 5 minutes

var _tokenStorage = new WeakMap();

var _isUnitOfWorkEnabled = new WeakMap();

var AbstractClient = /*#__PURE__*/function () {
  function AbstractClient(sdk, metadata) {
    var isUnitOfWorkEnabled = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

    _classCallCheck(this, AbstractClient);

    _defineProperty(this, "sdk", void 0);

    _tokenStorage.set(this, {
      writable: true,
      value: void 0
    });

    _defineProperty(this, "serializer", void 0);

    _defineProperty(this, "metadata", void 0);

    _isUnitOfWorkEnabled.set(this, {
      writable: true,
      value: void 0
    });

    this.sdk = sdk;

    _classPrivateFieldSet(this, _tokenStorage, sdk.tokenStorage);

    this.serializer = sdk.serializer;
    this.metadata = metadata;

    _classPrivateFieldSet(this, _isUnitOfWorkEnabled, isUnitOfWorkEnabled);
  }

  _createClass(AbstractClient, [{
    key: "withUnitOfWork",
    value: function withUnitOfWork(enabled) {
      // eslint-disable-next-line new-cap
      return generateRepository(this.sdk, this.metadata, enabled);
    }
  }, {
    key: "getDefaultParameters",
    value: function getDefaultParameters() {
      return {};
    } // eslint-disable-next-line @typescript-eslint/no-unused-vars

  }, {
    key: "getPathBase",
    value: function getPathBase(pathParameters) {
      return "/".concat(this.metadata.pathRoot);
    }
  }, {
    key: "getEntityURI",
    value: function getEntityURI(entity) {
      var idValue = this._getEntityIdentifier(entity);

      if (idValue === null) {
        throw new Error('Cannot call `getEntityURI for entity without id.`');
      }

      if (typeof idValue === 'number') {
        if (Number.isFinite(idValue)) {
          idValue = idValue.toString();
        } else {
          throw new Error('Unable to handle non-finite number');
        }
      }

      var pathBase = this.getPathBase({});

      if (idValue.indexOf(pathBase) > -1) {
        return idValue;
      }

      return "".concat(pathBase, "/").concat(idValue);
    }
    /**
     * get an entity by its id
     *
     * @param {string|number} id the entity identifier
     * @param {Record<string, unknown>} queryParam query parameters that will be added to the request
     * @param {Record<string, unknown>} pathParameters path parameters, will be pass to the `getPathBase` method
     * @param {Record<string, unknown>} requestParams parameters that will be send as second parameter to the `fetch` call
     */

  }, {
    key: "find",
    value: function find(id) {
      var queryParam = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var pathParameters = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var requestParams = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

      var url = this._generateUrlFromParams(queryParam, pathParameters, id);

      return this.deserializeResponse(this.authorizedFetch(url, requestParams), 'item');
    }
    /**
     * get a list of entities by some parameters
     *
     * @param {Record<string, unknown>} queryParam query parameters that will be added to the request
     * @param {Record<string, unknown>} pathParameters path parameters, will be pass to the `getPathBase` method
     * @param {Record<string, unknown>} requestParams parameters that will be send as second parameter to the `fetch` call
     */

  }, {
    key: "findBy",
    value: function findBy(queryParam) {
      var pathParameters = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var requestParams = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      var url = this._generateUrlFromParams(queryParam, pathParameters);

      return this.deserializeResponse(this.authorizedFetch(url, requestParams), 'list');
    }
    /**
     * get a list of all entities
     *
     * @param {Record<string, unknown>} queryParam query parameters that will be added to the request
     * @param {Record<string, unknown>} pathParameters path parameters, will be pass to the `getPathBase` method
     * @param {Record<string, unknown>} requestParams parameters that will be send as second parameter to the `fetch` call
     */

  }, {
    key: "findAll",
    value: function findAll() {
      var queryParam = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var pathParameters = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var requestParams = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      return this.findBy(queryParam, pathParameters, requestParams);
    }
    /**
     * create an entity
     *
     * @param {Record<string, unknown>} entity the entity to persist
     * @param {Record<string, unknown>} queryParam query parameters that will be added to the request
     * @param {Record<string, unknown>} pathParameters path parameters, will be pass to the `getPathBase` method
     * @param {Record<string, unknown>} requestParams parameters that will be send as second parameter to the `fetch` call
     */

  }, {
    key: "create",
    value: function create(entity) {
      var queryParam = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var pathParameters = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var requestParams = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
      var url = new URI(this.getPathBase(pathParameters));
      url.addSearch(queryParam);
      var oldSerializedModel = this.metadata.getDefaultSerializedModel();
      var newSerializedModel = this.serializer.normalizeItem(entity, this.metadata);
      var diff = this.sdk.unitOfWork.getDirtyData(newSerializedModel, oldSerializedModel, this.metadata);
      return this.deserializeResponse(this.authorizedFetch(url, _objectSpread2({
        method: 'POST',
        body: this.serializer.encodeItem(diff, this.metadata)
      }, requestParams)), 'item');
    }
    /**
     * update an entity
     *
     * @param {Record<string, unknown>} entity the entity to update
     * @param {Record<string, unknown>} queryParam query parameters that will be added to the request
     * @param {Record<string, unknown>} requestParams parameters that will be send as second parameter to the `fetch` call
     */

  }, {
    key: "update",
    value: function update(entity) {
      var queryParam = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var requestParams = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var url = new URI(this.getEntityURI(entity));
      url.addSearch(queryParam);
      var newSerializedModel = this.serializer.normalizeItem(entity, this.metadata);

      var identifier = this._getEntityIdentifier(newSerializedModel);

      var oldModel;

      if (identifier !== null) {
        oldModel = this.sdk.unitOfWork.getDirtyEntity(identifier);
      }

      if (oldModel) {
        newSerializedModel = this.sdk.unitOfWork.getDirtyData(newSerializedModel, oldModel, this.metadata);
      }

      return this.deserializeResponse(this.authorizedFetch(url, _objectSpread2({
        method: 'PUT',
        body: this.serializer.encodeItem(newSerializedModel, this.metadata)
      }, requestParams)), 'item');
    }
    /**
     * delete an entity
     *
     * @param {Record<string, unknown>} the entity to delete
     * @param {Record<string, unknown>} requestParams parameters that will be send as second parameter to the `fetch` call
     */

  }, {
    key: "delete",
    value: function _delete(entity) {
      var _this = this;

      var requestParams = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var url = this.getEntityURI(entity);

      var identifier = this._getEntityIdentifier(entity);

      return this.authorizedFetch(url, _objectSpread2({
        method: 'DELETE'
      }, requestParams)).then(function (response) {
        if (identifier !== null) {
          _this.sdk.unitOfWork.clear(identifier);
        }

        return response;
      });
    }
  }, {
    key: "deserializeResponse",
    value: function deserializeResponse(requestPromise, listOrItem) {
      var _this2 = this;

      return requestPromise.then(function (response) {
        return response.text().then(function (text) {
          return {
            response: response,
            text: text
          };
        });
      }).then(function (_ref) {
        var response = _ref.response,
            text = _ref.text;

        if (listOrItem === 'list') {
          // for list, we need to deserialize the result to get an object
          var itemList = _this2.serializer.deserializeList(text, _this2.metadata, response);

          if (_classPrivateFieldGet(_this2, _isUnitOfWorkEnabled)) {
            // eslint-disable-next-line no-restricted-syntax
            var _iterator = _createForOfIteratorHelper(itemList),
                _step;

            try {
              for (_iterator.s(); !(_step = _iterator.n()).done;) {
                var _decodedItem = _step.value;

                var _identifier = _this2._getEntityIdentifier(_decodedItem);

                var normalizedItem = _this2.serializer.normalizeItem(_decodedItem, _this2.metadata); // then we register the re-normalized item


                if (_identifier !== null) {
                  _this2.sdk.unitOfWork.registerClean(_identifier, normalizedItem);
                }
              }
            } catch (err) {
              _iterator.e(err);
            } finally {
              _iterator.f();
            }
          }

          return itemList;
        } // for items, we can just decode the item (ie. transform it to JS object)


        var decodedItem = _this2.serializer.decodeItem(text, _this2.metadata, response); // and register it directy without deserializing + renormalizing


        var identifier = _this2._getEntityIdentifier(decodedItem); // and finally return the denormalized item


        var item = _this2.serializer.denormalizeItem(decodedItem, _this2.metadata, response);

        if (_classPrivateFieldGet(_this2, _isUnitOfWorkEnabled) && identifier !== null) {
          _this2.sdk.unitOfWork.registerClean(identifier, _this2.serializer.normalizeItem(item, _this2.metadata));
        }

        return item;
      });
    }
  }, {
    key: "makeUri",
    value: function makeUri(input) {
      var url = input instanceof URI ? input : new URI(input);
      url.host(this.sdk.config.path).scheme(this.sdk.config.scheme);

      if (this.sdk.config.port) {
        url.port(String(this.sdk.config.port));
      }

      if (this.sdk.mapping.idPrefix) {
        var segments = url.segment();

        if (!url.pathname().startsWith(this.sdk.mapping.idPrefix)) {
          segments.unshift(this.sdk.mapping.idPrefix);
          url.segment(segments);
        }
      }

      return url;
    }
  }, {
    key: "authorizedFetch",
    value: function authorizedFetch(input) {
      var requestParams = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var url = this.makeUri(input);
      return this._fetchWithToken(url.toString(), requestParams);
    }
  }, {
    key: "_generateUrlFromParams",
    value: function _generateUrlFromParams(queryParam) {
      var pathParameters = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var id = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var params = queryParam;

      if (this.sdk.config.useDefaultParameters) {
        Object.assign(params, this.getDefaultParameters());
      }

      var pathBase = this.getPathBase(pathParameters);
      var url = null;

      if (id) {
        var testPathBase = this.sdk.mapping.idPrefix ? "".concat(this.sdk.mapping.idPrefix).concat(pathBase) : pathBase;

        if (typeof id === 'string' && id.startsWith(testPathBase)) {
          url = new URI(id);
        } else {
          url = new URI("".concat(pathBase, "/").concat(id));
        }
      } else {
        url = new URI(pathBase);
      }

      if (params) {
        url.addSearch(params);
      }

      return url;
    }
  }, {
    key: "_fetchWithToken",
    value: function _fetchWithToken(input) {
      var _this3 = this;

      var requestParams = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      if (!input) {
        throw new Error('input is empty');
      }

      if (_classPrivateFieldGet(this, _tokenStorage)) {
        return _classPrivateFieldGet(this, _tokenStorage).getCurrentTokenExpiresIn().then(function (accessTokenExpiresIn) {
          if (accessTokenExpiresIn !== null && accessTokenExpiresIn <= EXPIRE_LIMIT_SECONDS) {
            return _classPrivateFieldGet(_this3, _tokenStorage).refreshToken().then(function (refreshedTokenObject) {
              return refreshedTokenObject.access_token;
            })["catch"](function (e) {
              _this3._handleRefreshTokenFailure(e);

              throw e;
            });
          }

          return _classPrivateFieldGet(_this3, _tokenStorage).getAccessToken();
        }).then(function (token) {
          return _this3._doFetch(token, input, requestParams);
        });
      }

      return this._doFetch(null, input, requestParams);
    }
  }, {
    key: "_refreshTokenAndRefetch",
    value: function _refreshTokenAndRefetch(input) {
      var _this4 = this;

      var requestParams = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      return _classPrivateFieldGet(this, _tokenStorage).refreshToken().then(function () {
        // eslint-disable-next-line prefer-const
        var headers = requestParams.headers,
            rest = _objectWithoutProperties(requestParams, ["headers"]);

        var updatedRequestParams = _objectSpread2(_objectSpread2({}, rest), {}, {
          headers: removeAuthorization(headers)
        });

        return _this4._fetchWithToken(input, updatedRequestParams);
      })["catch"](function (e) {
        _this4._handleRefreshTokenFailure(e);

        throw e;
      });
    }
  }, {
    key: "_manageUnauthorized",
    value: function _manageUnauthorized(response, input) {
      var _this5 = this;

      var requestParams = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var error = getHttpErrorFromResponse(response); // https://tools.ietf.org/html/rfc2617#section-1.2

      var authorizationHeader = response.headers.get('www-authenticate');

      if (authorizationHeader) {
        var invalidGrant = authorizationHeader.indexOf('error="invalid_grant"') > -1;

        if (invalidGrant && _classPrivateFieldGet(this, _tokenStorage)) {
          return this._refreshTokenAndRefetch(input, requestParams);
        }

        throw error;
      } else {
        // if www-authenticate header is missing, try and read json response
        return response.json().then(function (body) {
          if (_classPrivateFieldGet(_this5, _tokenStorage) && (body.error === 'invalid_scope' || body.error === 'access_denied')) {
            return _this5._refreshTokenAndRefetch(input, requestParams);
          }

          throw error;
        })["catch"](function (err) {
          if (err instanceof OauthError) {
            throw err;
          }

          throw error;
        });
      }
    }
  }, {
    key: "_doFetch",
    value: function _doFetch(accessToken, input, requestParams) {
      var _this6 = this;

      var params = requestParams;
      var baseHeaders = {};

      if (params.method !== 'GET' || params.method !== 'GET' && params.method !== 'DELETE') {
        baseHeaders = {
          'Content-Type': 'application/json'
        };
      }

      if (accessToken) {
        baseHeaders.Authorization = "".concat(this.sdk.config.authorizationType, " ").concat(accessToken);
      }

      if (params) {
        if (!params.headers) {
          params.headers = {};
        }

        params.headers = Object.assign(baseHeaders, params.headers);
      } else {
        params = {
          headers: baseHeaders
        };
      }

      if (params.headers) {
        params.headers = removeUndefinedHeaders(params.headers);
      }

      var logId;

      if (this.sdk.logger) {
        logId = this.sdk.logger.logRequest(_objectSpread2({
          url: input
        }, params));
      } // eslint-disable-next-line consistent-return


      return fetch(input, params).then(function (response) {
        if (_this6.sdk.logger) {
          _this6.sdk.logger.logResponse(response, logId);
        }

        if (response.status < 400) {
          return response;
        }

        if (response.status === 401) {
          return _this6._manageUnauthorized(response, input, params);
        }

        var httpError = getHttpErrorFromResponse(response);
        throw httpError;
      });
    }
  }, {
    key: "_getEntityIdentifier",
    value: function _getEntityIdentifier(object) {
      var idKey = this.metadata.getIdentifierAttribute().serializedKey; // eslint-disable-next-line @typescript-eslint/ban-ts-comment
      // @ts-ignore

      return object[idKey];
    }
  }, {
    key: "_handleRefreshTokenFailure",
    value: function _handleRefreshTokenFailure(error) {
      var _this7 = this;

      if (error instanceof OauthError) {
        _classPrivateFieldGet(this, _tokenStorage).logout().then(function () {
          if (_this7.sdk.config.onRefreshTokenFailure) {
            _this7.sdk.config.onRefreshTokenFailure(error);
          }
        });
      }
    }
  }]);

  return AbstractClient;
}();

var _attributeList = new WeakMap();

var _relationList = new WeakMap();

var _identifierAttribute = new WeakMap();

var ClassMetadata = /*#__PURE__*/function () {
  /**
   * @param {string} key mandatory, will be passed in your serializer
   * @param {string|null} pathRoot the endpoint of your API: will be added to the mapping prefix ('/v1' here)
   * @param {typeof AbstractClient} repositoryClass [Overriding repository]{@link https://github.com/mapado/rest-client-js-sdk#overriding-repository} for more detail
   */
  function ClassMetadata(key) {
    var pathRoot = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    var repositoryClass = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : AbstractClient;

    _classCallCheck(this, ClassMetadata);

    _defineProperty(this, "key", void 0);

    _defineProperty(this, "pathRoot", void 0);

    _defineProperty(this, "repositoryClass", void 0);

    _attributeList.set(this, {
      writable: true,
      value: void 0
    });

    _relationList.set(this, {
      writable: true,
      value: void 0
    });

    _identifierAttribute.set(this, {
      writable: true,
      value: void 0
    });

    if (!key) {
      throw new TypeError('key attribute are required');
    }

    this.key = key;
    this.pathRoot = pathRoot || key; // this.modelName = modelName;

    this.repositoryClass = repositoryClass;

    _classPrivateFieldSet(this, _attributeList, {});

    _classPrivateFieldSet(this, _relationList, {});
  }

  _createClass(ClassMetadata, [{
    key: "getAttribute",
    value: function getAttribute(name) {
      return _classPrivateFieldGet(this, _attributeList)[name];
    }
  }, {
    key: "hasIdentifierAttribute",
    value: function hasIdentifierAttribute() {
      return !!_classPrivateFieldGet(this, _identifierAttribute);
    }
  }, {
    key: "getIdentifierAttribute",
    value: function getIdentifierAttribute() {
      if (!_classPrivateFieldGet(this, _identifierAttribute)) {
        throw new TypeError("\"".concat(this.key, "\" has no identifier attribute set. Did you call \"setAttributeList\" first ?"));
      }

      return _classPrivateFieldGet(this, _identifierAttribute);
    }
  }, {
    key: "getAttributeList",
    value: function getAttributeList() {
      return _classPrivateFieldGet(this, _attributeList);
    }
  }, {
    key: "setAttributeList",
    value: function setAttributeList(attributeList) {
      var _this = this;

      _classPrivateFieldSet(this, _attributeList, {});

      _classPrivateFieldSet(this, _identifierAttribute, undefined);

      attributeList.forEach(function (attribute) {
        _classPrivateFieldGet(_this, _attributeList)[attribute.serializedKey] = attribute;

        if (attribute.isIdentifier) {
          _classPrivateFieldSet(_this, _identifierAttribute, attribute);
        }
      });

      if (!_classPrivateFieldGet(this, _identifierAttribute)) {
        throw new TypeError("\"".concat(this.key, "\" has no identifier attribute set. You must set all your attributes in one time and send an attribute with \"isIdentifier=true\""));
      }
    }
  }, {
    key: "setRelationList",
    value: function setRelationList(relationList) {
      var _this2 = this;

      _classPrivateFieldSet(this, _relationList, {});

      relationList.forEach(function (relation) {
        _classPrivateFieldGet(_this2, _relationList)[relation.serializedKey] = relation;
        _classPrivateFieldGet(_this2, _attributeList)[relation.serializedKey] = new Attribute(relation.serializedKey, relation.serializedKey, relation.isRelationToMany() ? 'array' : 'object');
      });
    }
  }, {
    key: "getRelation",
    value: function getRelation(key) {
      return _classPrivateFieldGet(this, _relationList)[key];
    }
  }, {
    key: "getDefaultSerializedModel",
    value: function getDefaultSerializedModel() {
      var _this3 = this;

      var out = {};
      Object.keys(_classPrivateFieldGet(this, _attributeList)).forEach(function (serializedKey) {
        out[serializedKey] = null;
      });
      Object.keys(_classPrivateFieldGet(this, _relationList)).forEach(function (serializedKey) {
        var relation = _classPrivateFieldGet(_this3, _relationList)[serializedKey];

        if (relation.isRelationToMany()) {
          out[serializedKey] = [];
        }
      });
      return out;
    }
  }]);

  return ClassMetadata;
}();

var RelationTypes;

(function (RelationTypes) {
  RelationTypes["ONE_TO_ONE"] = "ONE_TO_ONE";
  RelationTypes["ONE_TO_MANY"] = "ONE_TO_MANY";
  RelationTypes["MANY_TO_MANY"] = "MANY_TO_MANY";
  RelationTypes["MANY_TO_ONE"] = "MANY_TO_ONE";
})(RelationTypes || (RelationTypes = {}));

var Relation = /*#__PURE__*/function () {
  /**
   * @param {RelationTypes} type the type of relation
   * @param {string} targetMetadataKey must match the first argument of `ClassMetadata` constructor of the target entity
   * @param {string} serializedKey the key returned from your API
   * @param {string|null} attributeName the name in your entity, default to the `serializedKey` attribute
   */
  function Relation(type, targetMetadataKey, serializedKey) {
    var attributeName = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;

    _classCallCheck(this, Relation);

    _defineProperty(this, "type", void 0);

    _defineProperty(this, "targetMetadataKey", void 0);

    _defineProperty(this, "serializedKey", void 0);

    _defineProperty(this, "attributeName", void 0);

    this.type = type;
    this.targetMetadataKey = targetMetadataKey;
    this.serializedKey = serializedKey;
    this.attributeName = attributeName || this.serializedKey;
  }

  _createClass(Relation, [{
    key: "isOneToOne",
    value: function isOneToOne() {
      return this.type === Relation.ONE_TO_ONE;
    }
  }, {
    key: "isOneToMany",
    value: function isOneToMany() {
      return this.type === Relation.ONE_TO_MANY;
    }
  }, {
    key: "isManyToOne",
    value: function isManyToOne() {
      return this.type === Relation.MANY_TO_ONE;
    }
  }, {
    key: "isManyToMany",
    value: function isManyToMany() {
      return this.type === Relation.MANY_TO_MANY;
    }
  }, {
    key: "isRelationToMany",
    value: function isRelationToMany() {
      return this.isManyToMany() || this.isOneToMany();
    }
  }, {
    key: "isRelationToOne",
    value: function isRelationToOne() {
      return this.isManyToOne() || this.isOneToOne();
    }
  }]);

  return Relation;
}();

_defineProperty(Relation, "ONE_TO_ONE", RelationTypes.ONE_TO_ONE);

_defineProperty(Relation, "ONE_TO_MANY", RelationTypes.ONE_TO_MANY);

_defineProperty(Relation, "MANY_TO_ONE", RelationTypes.MANY_TO_ONE);

_defineProperty(Relation, "MANY_TO_MANY", RelationTypes.MANY_TO_MANY);

/* eslint-disable */
// "fork" of https://github.com/facebook/immutable-js/blob/v4.0.0-rc.9/src/Predicates.js
// because tree-shaking does not seems to work as expected

/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var IS_ITERABLE_SENTINEL = '@@__IMMUTABLE_ITERABLE__@@';
var IS_RECORD_SENTINEL = '@@__IMMUTABLE_RECORD__@@';
function isImmutable(maybeImmutable) {
  return isCollection(maybeImmutable) || isRecord(maybeImmutable);
}
function isCollection(maybeCollection) {
  return !!(maybeCollection && maybeCollection[IS_ITERABLE_SENTINEL]);
}
function isRecord(maybeRecord) {
  return !!(maybeRecord && maybeRecord[IS_RECORD_SENTINEL]);
}

/**
 * deep comparaison between objects
 */
function objectDiffers(left, right) {
  var result = diff(left, right);
  return result ? result.length > 0 : false;
}
/**
 * get the id of an entity or return itself if string
 */


function getEntityId(stringOrEntity, idSerializedKey) {
  if (_typeof(stringOrEntity) !== 'object') {
    return stringOrEntity;
  } // eslint-disable-next-line @typescript-eslint/ban-ts-comment
  // @ts-ignore


  return stringOrEntity[idSerializedKey];
}
/**
 * find old relation value from the new relation id
 * if not found, returs the default serilazed model
 */


function findOldRelation(newRelationValue, oldRelationValue, classMetadata) {
  var idSerializedKey = classMetadata.getIdentifierAttribute().serializedKey; // eslint-disable-next-line @typescript-eslint/ban-ts-comment
  // @ts-ignore

  var relationValueId = getEntityId(newRelationValue, idSerializedKey);
  var foundValue = oldRelationValue && oldRelationValue.find(function (innerOldRelationValue) {
    var oldRelationValueId = getEntityId(innerOldRelationValue, idSerializedKey);
    return relationValueId === oldRelationValueId;
  });

  if (foundValue) {
    return foundValue;
  }

  return classMetadata.getDefaultSerializedModel();
}
/**
 * add all identifier from one to many relation list
 */


function getIdentifierForList(newValue, idSerializedKey) {
  return newValue.map(function (value) {
    if (Object.keys(value).includes(idSerializedKey)) {
      return _defineProperty({}, idSerializedKey, value[idSerializedKey]);
    }

    if (typeof value === 'string') {
      return value;
    }

    throw new TypeError('new value should include a list of string or objects containing the serialized key');
  });
}

var _storage = new WeakMap();

var _enabled = new WeakMap();

var UnitOfWork = /*#__PURE__*/function () {
  function UnitOfWork(mapping) {
    var enabled = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

    _classCallCheck(this, UnitOfWork);

    _defineProperty(this, "mapping", void 0);

    _storage.set(this, {
      writable: true,
      value: void 0
    });

    _enabled.set(this, {
      writable: true,
      value: void 0
    });

    this.mapping = mapping;

    _classPrivateFieldSet(this, _enabled, enabled);

    _classPrivateFieldSet(this, _storage, {});
  }

  _createClass(UnitOfWork, [{
    key: "registerClean",
    value: function registerClean(id, entity) {
      if (!_classPrivateFieldGet(this, _enabled)) {
        return;
      }

      if (isImmutable(entity)) {
        _classPrivateFieldGet(this, _storage)[id] = entity;
      } else {
        _classPrivateFieldGet(this, _storage)[id] = _objectSpread2({}, entity);
      }
    }
  }, {
    key: "getDirtyEntity",
    value: function getDirtyEntity(id) {
      return _classPrivateFieldGet(this, _storage)[id];
    }
  }, {
    key: "clear",
    value: function clear(id) {
      delete _classPrivateFieldGet(this, _storage)[id];
    }
  }, {
    key: "getDirtyData",
    value: function getDirtyData(newSerializedModel, oldSerializedModel, classMetadata) {
      return this._getDirtyFields(newSerializedModel, oldSerializedModel, classMetadata);
    }
  }, {
    key: "_getDirtyFieldsForAttribute",
    value: function _getDirtyFieldsForAttribute(dirtyFieldsParam, key, attribute, oldValue, newValue) {
      var dirtyFields = dirtyFieldsParam;

      if (attribute.type === 'object') {
        if (oldValue === undefined || objectDiffers(oldValue, newValue)) {
          dirtyFields[key] = newValue;
        }
      } else if (oldValue !== newValue) {
        dirtyFields[key] = newValue;
      }

      return dirtyFields;
    }
  }, {
    key: "_getDirtyFieldsForManyToOne",
    value: function _getDirtyFieldsForManyToOne(dirtyFieldsParam, key, oldValue, newValue, relationMetadata, idSerializedKey) {
      var dirtyFields = dirtyFieldsParam;

      if (oldValue !== newValue) {
        if (newValue === null) {
          dirtyFields[key] = null;
          return dirtyFields;
        }

        if (typeof oldValue === 'string' || typeof newValue === 'string') {
          dirtyFields[key] = newValue;
        }

        var recursiveDiff = this._getDirtyFields(newValue, oldValue, relationMetadata);

        if (Object.keys(recursiveDiff).length > 0) {
          recursiveDiff[idSerializedKey] = getEntityId(newValue, idSerializedKey);
          dirtyFields[key] = recursiveDiff;
        }
      }

      return dirtyFields;
    }
  }, {
    key: "_getDirtyFieldsForOneToMany",
    value: function _getDirtyFieldsForOneToMany(dirtyFieldsParam, key, idSerializedKey, relationMetadata, oldValue, newValue) {
      var _this = this;

      var dirtyFields = dirtyFieldsParam;
      var newValueLength = newValue ? newValue.length : 0;
      var oldValueLength = oldValue ? oldValue.length : 0; // number of items changed

      if (newValueLength !== oldValueLength) {
        dirtyFields[key] = getIdentifierForList(newValue, idSerializedKey);
      }

      if (newValue && newValue.length > 0) {
        if (dirtyFields[key] === undefined) {
          dirtyFields[key] = [];
        }

        var relationList = newValue;
        relationList.forEach(function (newRelationValue, relationAttributeName) {
          var oldRelationValue = findOldRelation(newRelationValue, oldValue, relationMetadata);

          if (newRelationValue !== oldRelationValue) {
            if (typeof newRelationValue === 'string' || typeof oldRelationValue === 'string') {
              dirtyFields[key][relationAttributeName] = newRelationValue;
              return;
            }

            var recursiveDiff = _this._getDirtyFields(newRelationValue, oldRelationValue, relationMetadata);

            if (Object.keys(recursiveDiff).length > 0) {
              var entityId = getEntityId(newRelationValue, idSerializedKey);

              if (entityId !== null) {
                recursiveDiff[idSerializedKey] = entityId;
              }

              if (dirtyFields[key][relationAttributeName]) {
                Object.assign(dirtyFields[key][relationAttributeName], recursiveDiff);
              } else {
                dirtyFields[key][relationAttributeName] = recursiveDiff;
              }
            }
          }
        });

        if (dirtyFields[key].length > 0) {
          // add identifier because one or more object linked has been updated
          // see test: 'get dirty data many to one update item'
          dirtyFields[key] = Object.assign(getIdentifierForList(newValue, idSerializedKey), dirtyFields[key]);
        } else {
          // no changes, no need to send the key with an empty array as value
          delete dirtyFields[key];
        }
      }

      return dirtyFields;
    }
  }, {
    key: "_getDirtyFields",
    value: function _getDirtyFields(newSerializedModel, oldSerializedModel, classMetadata) {
      var _this2 = this;

      var dirtyFields = {};
      Object.values(classMetadata.getAttributeList()).forEach(function (attribute) {
        var key = attribute.attributeName;
        var newValue = newSerializedModel[key];
        var oldValue = oldSerializedModel ? oldSerializedModel[key] : null;
        var currentRelation = classMetadata.getRelation(attribute.serializedKey);

        if (newValue === undefined) {
          return;
        } // not a relation


        if (!currentRelation) {
          dirtyFields = _this2._getDirtyFieldsForAttribute(dirtyFields, key, attribute, oldValue, newValue);
          return;
        }

        var relationMetadata = _this2.mapping.getClassMetadataByKey(currentRelation.targetMetadataKey);

        if (!relationMetadata) {
          throw new TypeError("relation metadata is not set for relation ".concat(classMetadata.key, ".").concat(currentRelation.targetMetadataKey));
        }

        var idSerializedKey = relationMetadata.getIdentifierAttribute().serializedKey; // MANY_TO_ONE relation

        if (currentRelation.isRelationToOne()) {
          dirtyFields = _this2._getDirtyFieldsForManyToOne(dirtyFields, key, oldValue, newValue, relationMetadata, idSerializedKey);
          return;
        } // *_TO_MANY relation


        dirtyFields = _this2._getDirtyFieldsForOneToMany(dirtyFields, key, idSerializedKey, relationMetadata, oldValue, newValue);
      });
      return dirtyFields;
    }
  }]);

  return UnitOfWork;
}();

/* eslint-disable @typescript-eslint/no-unused-vars */
var Serializer = /*#__PURE__*/function () {
  function Serializer() {
    _classCallCheck(this, Serializer);
  }

  _createClass(Serializer, [{
    key: "normalizeItem",

    /**
     * convert an entity to a plain javascript object
     * @param {object} entity - The entity to convert
     * @param {ClassMetadata} classMetadata - the class metadata
     * @return {object} the object to serialize
     */
    value: function normalizeItem(entity, classMetadata) {
      return entity;
    }
    /**
     * convert a plain javascript object to string
     * @param {object} object - The object to convert to convert
     * @param {ClassMetadata} classMetadata - the class metadata
     * @return {string} the content of the request
     */

  }, {
    key: "encodeItem",
    value: function encodeItem(object, classMetadata) {
      throw new TypeError('`encodeItem` method must be implemented');
    }
    /**
     * convert an entity to string that will be sent as the request content
     * @param {any} entity - The entity to convert
     * @param {ClassMetadata} classMetadata - the class metadata
     * @return {string} the content of the request
     */

  }, {
    key: "serializeItem",
    value: function serializeItem(object, classMetadata) {
      var noralizedData = this.normalizeItem(object, classMetadata);
      return this.encodeItem(noralizedData, classMetadata);
    }
    /**
     * convert a plain object to an entity
     * @param {object} object - The plain javascript object
     * @param {ClassMetadata} classMetadata - the class metadata
     * @param {Record<string, unknown>} response - the HTTP response
     * @return {object} an entity
     */

  }, {
    key: "denormalizeItem",
    value: function denormalizeItem(object, classMetadata, response) {
      return object;
    }
    /**
     * convert a string containing an object to a plain javascript object
     * @param {string} rawData - The string fetched from the response
     * @param {ClassMetadata} classMetadata - the class metadata
     * @param {Record<string, unknown>} response - the HTTP response
     * @return {object} the normalized object
     */

  }, {
    key: "decodeItem",
    value: function decodeItem(rawData, classMetadata, response) {
      throw new TypeError('`decodeItem` method must be implemented');
    }
    /**
     * convert a string containing an object to an entity
     * @param {string} rawData - The string fetched from the response
     * @param {ClassMetadata} classMetadata - the class metadata
     * @param {Record<string, unknown>} response - the HTTP response
     * @return {object} the entity
     */

  }, {
    key: "deserializeItem",
    value: function deserializeItem(rawData, classMetadata, response) {
      var object = this.decodeItem(rawData, classMetadata, response);
      return this.denormalizeItem(object, classMetadata, response);
    }
    /**
     * convert a plain object list to an entity list
     * @param {Iterable<object>} objectList - The plain javascript object list (or an iterable object)
     * @param {ClassMetadata} classMetadata - the class metadata
     * @param {Record<string, unknown>} response - the HTTP response
     * @return {Iterable<object>} a list of entities
     */

  }, {
    key: "denormalizeList",
    value: function denormalizeList(objectList, classMetadata, response) {
      return objectList; // weird conversion as the declaration of list type is fuzzy
    }
    /**
     * convert a string containing a list of objects to a list of plain javascript objects
     * @param {string} rawListData - The string fetched from the response
     * @param {ClassMetadata} classMetadata - the class metadata
     * @param {Record<string, unknown>} response - the HTTP response
     * @return {Iterable<object>} a list of normalized objects
     */

  }, {
    key: "decodeList",
    value: function decodeList(rawListData, classMetadata, response) {
      throw new TypeError('`deserializeList` method must be implemented');
    }
    /**
     * convert a string containing a list of objects to a list of entities
     * @param {string} rawListData - The string fetched from the response
     * @param {ClassMetadata} classMetadata - the class metadata
     * @param {Record<string, unknown>} response - the HTTP response
     * @return {Iterable<object>} a list of entities
     */

  }, {
    key: "deserializeList",
    value: function deserializeList(rawListData, classMetadata, response) {
      var objectList = this.decodeList(rawListData, classMetadata, response);
      return this.denormalizeList(objectList, classMetadata, response);
    }
  }]);

  return Serializer;
}();

var JsSerializer = /*#__PURE__*/function (_Serializer) {
  _inherits(JsSerializer, _Serializer);

  var _super = _createSuper(JsSerializer);

  function JsSerializer() {
    _classCallCheck(this, JsSerializer);

    return _super.apply(this, arguments);
  }

  _createClass(JsSerializer, [{
    key: "encodeItem",
    value: function encodeItem(object, classMetadata) {
      return JSON.stringify(object);
    }
  }, {
    key: "decodeItem",
    value: function decodeItem(rawData, classMetadata, response) {
      return JSON.parse(rawData);
    }
  }, {
    key: "decodeList",
    value: function decodeList(rawListData, classMetadata, response) {
      return JSON.parse(rawListData);
    }
  }]);

  return JsSerializer;
}(Serializer);

function levenshteinDistance(a, b) {
  var matrix = []; // Increment along the first column of each row

  for (var i = 0; i <= b.length; i += 1) {
    matrix[i] = [i];
  } // Increment each column in the first row


  for (var j = 0; j <= a.length; j += 1) {
    matrix[0][j] = j;
  } // Fill in the rest of the matrix


  for (var _i = 1; _i <= b.length; _i += 1) {
    for (var _j = 1; _j <= a.length; _j += 1) {
      if (b.charAt(_i - 1) === a.charAt(_j - 1)) {
        matrix[_i][_j] = matrix[_i - 1][_j - 1];
      } else {
        matrix[_i][_j] = Math.min(matrix[_i - 1][_j - 1] + 1, // substitution
        matrix[_i][_j - 1] + 1, // insertion
        matrix[_i - 1][_j] + 1 // deletion
        );
      }
    }
  }

  return matrix[b.length][a.length];
} // eslint-disable-next-line import/prefer-default-export


function findClosestWord(word, list) {
  var maxDistance = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : Infinity;
  var closestWord = null;
  var minDistance = Infinity; // eslint-disable-next-line no-plusplus

  for (var i = 0; i < list.length; i += 1) {
    var candidate = list[i];
    var distance = levenshteinDistance(word, candidate);

    if (distance < minDistance && distance <= maxDistance) {
      minDistance = distance;
      closestWord = candidate;
    }
  }

  return closestWord;
}

var generateId = function generateId() {
  return "rest-client-sdk|".concat(Date.now(), "-").concat(Math.floor(Math.random() * (9e12 - 1)) + 1e12);
};

function serializeRequest(req) {
  var request = _objectSpread2({}, req); // Make a clone, useful for doing destructive things


  return {
    method: request.method,
    // The Request Method, e.g. GET, POST, DELETE
    url: request.url,
    // The URL
    headers: request.headers ? convertToRecord(request.headers) : undefined,
    body: typeof request.body === 'string' ? request.body : undefined
  };
} // eslint-disable-next-line import/prefer-default-export


var _history = new WeakMap();

var Logger = /*#__PURE__*/function () {
  _createClass(Logger, [{
    key: "history",
    get: function get() {
      return _classPrivateFieldGet(this, _history);
    }
  }]);

  function Logger() {
    _classCallCheck(this, Logger);

    _history.set(this, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldSet(this, _history, []);
  }

  _createClass(Logger, [{
    key: "logRequest",
    value: function logRequest(params) {
      var log = {
        id: generateId(),
        request: serializeRequest(params),
        logTimes: {
          request: Date.now()
        }
      };

      _classPrivateFieldGet(this, _history).push(log);

      return log.id;
    }
  }, {
    key: "logResponse",
    value: function logResponse(response, requestId) {
      var id = requestId || generateId(); // console.log('clone');
      // const clonedResponse = response.clone(); // THIS IS THE LINE THAT CAUSES THE PROBLEM
      // console.log('after clone', clonedResponse.status);

      var logContent = {
        status: response.status,
        // clonedResponse.status,
        headers: Object.fromEntries(response.headers)
      };

      var foundLogIndex = _classPrivateFieldGet(this, _history).findIndex(function (log) {
        return log.id === id;
      });

      if (foundLogIndex > -1) {
        _classPrivateFieldGet(this, _history)[foundLogIndex].response = logContent;
        _classPrivateFieldGet(this, _history)[foundLogIndex].logTimes.response = Date.now();
      } else {
        _classPrivateFieldGet(this, _history).push({
          id: id,
          response: logContent,
          logTimes: {
            response: Date.now()
          }
        });
      }

      return id;
    }
  }]);

  return Logger;
}();

var _repositoryList = new WeakMap();

var RestClientSdk = /*#__PURE__*/function () {
  function RestClientSdk(tokenStorage, config, mapping) {
    var serializer = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : new JsSerializer();

    _classCallCheck(this, RestClientSdk);

    _defineProperty(this, "config", void 0);

    _defineProperty(this, "tokenStorage", void 0);

    _defineProperty(this, "serializer", void 0);

    _defineProperty(this, "mapping", void 0);

    _defineProperty(this, "unitOfWork", void 0);

    _repositoryList.set(this, {
      writable: true,
      value: void 0
    });

    _defineProperty(this, "logger", void 0);

    this.checkConfigValidity(config);

    if (!(mapping instanceof Mapping)) {
      throw new TypeError('mapping should be an instance of `Mapping`');
    }

    this.config = this._mergeWithBaseConfig(config);
    this.tokenStorage = tokenStorage;
    this.serializer = serializer;
    this.mapping = mapping;
    this.unitOfWork = new UnitOfWork(this.mapping, this.config.unitOfWorkEnabled);

    if (config.loggerEnabled) {
      this.logger = new Logger();
    }

    _classPrivateFieldSet(this, _repositoryList, {});
  }
  /**
   * get a repository by it's metadata "key" attribute
   *
   * @param {string} key the repository "key" (the first argument of `new ClassMetadata`)
   */


  _createClass(RestClientSdk, [{
    key: "getRepository",
    value: function getRepository(key) {
      if (!_classPrivateFieldGet(this, _repositoryList)[key]) {
        var metadata = this.mapping.getClassMetadataByKey(key);

        if (!metadata) {
          var closeKey = findClosestWord(key, this.mapping.getMappingKeys(), 5);
          var suggestions = closeKey ? " Did you mean \"".concat(closeKey, "\"?") : '';
          throw new Error("Unable to get metadata for repository \"".concat(key, "\".").concat(suggestions));
        } // eslint-disable-next-line new-cap


        _classPrivateFieldGet(this, _repositoryList)[key] = generateRepository(this, metadata, this.config.unitOfWorkEnabled);
      } // eslint-disable-next-line @typescript-eslint/no-non-null-assertion


      return _classPrivateFieldGet(this, _repositoryList)[key];
    }
  }, {
    key: "_mergeWithBaseConfig",
    value: function _mergeWithBaseConfig(config) {
      var newConfig = config;
      newConfig.useDefaultParameters = config.useDefaultParameters === undefined ? true : config.useDefaultParameters;
      newConfig.authorizationType = config.authorizationType || 'Bearer';
      return newConfig;
    }
  }, {
    key: "checkConfigValidity",
    value: function checkConfigValidity(config) {
      if (!(config && config.path && config.scheme)) {
        throw new RangeError("SDK config is not valid, it should contain a \"path\", a \"scheme\" parameter,\n        and may contain a \"port\" and a \"useDefaultParameters\" parameter");
      }
    }
  }]);

  return RestClientSdk;
}();

var AbstractTokenGenerator = /*#__PURE__*/function () {
  function AbstractTokenGenerator(tokenGeneratorConfig, logger) {
    _classCallCheck(this, AbstractTokenGenerator);

    _defineProperty(this, "tokenGeneratorConfig", void 0);

    _defineProperty(this, "logger", void 0);

    if (logger) {
      this.logger = logger;
    }

    this.tokenGeneratorConfig = tokenGeneratorConfig;

    if (typeof this.checkTokenGeneratorConfig === 'function') {
      this.checkTokenGeneratorConfig(this.tokenGeneratorConfig);
    }
  }

  _createClass(AbstractTokenGenerator, [{
    key: "_manageOauthError",

    /** @deprecated */
    value: function _manageOauthError(response) {
      return response.clone().json().then(function (body) {
        if (body.error === 'invalid_grant') {
          throw new InvalidGrantError(body.error, getHttpErrorFromResponse(response));
        }

        if (body.error === 'invalid_scope') {
          throw new InvalidScopeError(body.error, getHttpErrorFromResponse(response));
        }

        throw new OauthError(body.error, getHttpErrorFromResponse(response));
      })["catch"](function (err) {
        if (!(err instanceof OauthError)) {
          throw new OauthError(err.type, getHttpErrorFromResponse(response));
        }

        throw err;
      });
    }
  }, {
    key: "generateUrlFromConfig",
    value: function generateUrlFromConfig(config) {
      var uri = new URI("".concat(config.scheme, "://").concat(config.path));

      if (config.port) {
        uri.port(config.port);
      }

      return uri.toString();
    }
  }]);

  return AbstractTokenGenerator;
}();

/**
 * This generator take cares of the second part of the authorization code flow : the part where you have a "code"
 * and you have validated the "state"
 * @See {@link https://oauth2.thephpleague.com/authorization-server/auth-code-grant/|the great article of the PHP League} about authorization code flow.
 */
var AuthorizationCodeFlowTokenGenerator = /*#__PURE__*/function (_AbstractTokenGenerat) {
  _inherits(AuthorizationCodeFlowTokenGenerator, _AbstractTokenGenerat);

  var _super = _createSuper(AuthorizationCodeFlowTokenGenerator);

  function AuthorizationCodeFlowTokenGenerator() {
    _classCallCheck(this, AuthorizationCodeFlowTokenGenerator);

    return _super.apply(this, arguments);
  }

  _createClass(AuthorizationCodeFlowTokenGenerator, [{
    key: "generateToken",

    /**
     * This function needs no generate an access token
     */
    value: function generateToken(parameters) {
      this._checkGenerateParameters(parameters);

      var url = this.generateUrlFromConfig(this.tokenGeneratorConfig);
      var params = {
        method: 'POST',
        headers: {
          'Content-Type': 'application/x-www-form-urlencoded'
        },
        body: new URLSearchParams({
          grant_type: 'authorization_code',
          client_id: this.tokenGeneratorConfig.clientId,
          client_secret: this.tokenGeneratorConfig.clientSecret,
          // TODO : secure this ?
          redirect_uri: this.tokenGeneratorConfig.redirectUri,
          code: parameters.code
        }).toString()
      };

      if (this.logger) {
        this.logger.logRequest(_objectSpread2({
          url: url
        }, params));
      }

      return fetch(url, params);
    }
    /**
     * This function needs to refresh the current possibly expired access token
     * and return a Promise that will be resolved with a fresh access token
     */

  }, {
    key: "refreshToken",
    value: function refreshToken(oldAccessToken) {
      if (!oldAccessToken) {
        throw new Error('refresh_token is not set. Did you called `generateToken` before ?');
      }

      if (!(oldAccessToken === null || oldAccessToken === void 0 ? void 0 : oldAccessToken.refresh_token)) {
        throw new Error('Unable to refreshToken as there are no refresh_token');
      }

      var url = this.generateUrlFromConfig(this.tokenGeneratorConfig);
      var params = {
        method: 'POST',
        headers: {
          'Content-Type': 'application/x-www-form-urlencoded'
        },
        body: new URLSearchParams({
          grant_type: 'refresh_token',
          client_id: this.tokenGeneratorConfig.clientId,
          client_secret: this.tokenGeneratorConfig.clientSecret,
          refresh_token: oldAccessToken.refresh_token
        }).toString()
      };

      if (this.logger) {
        this.logger.logRequest(_objectSpread2({
          url: url
        }, params));
      }

      return fetch(url, params);
    }
  }, {
    key: "checkTokenGeneratorConfig",
    value: function checkTokenGeneratorConfig(config) {
      if (!config || Object.keys(config).length === 0) {
        throw new RangeError('TokenGenerator config must be set');
      }

      if (!(config.path && config.scheme)) {
        throw new RangeError('TokenGenerator config is not valid, it should contain a "path", a "scheme" parameter');
      }

      if (!(config.clientId && config.clientSecret)) {
        throw new RangeError('TokenGenerator config is not valid, it should contain a "clientId", a "clientSecret" parameter');
      }

      if (!config.redirectUri) {
        throw new RangeError('TokenGenerator config is not valid, it should contain a "redirectUri" parameter');
      }
    }
  }, {
    key: "_checkGenerateParameters",
    value: function _checkGenerateParameters(parameters) {
      if (!(parameters && Object.keys(parameters).length > 0)) {
        throw new RangeError('parameters must be set');
      }

      if (!parameters.code) {
        throw new RangeError('"code" must be passed as parameter');
      }
    }
  }]);

  return AuthorizationCodeFlowTokenGenerator;
}(AbstractTokenGenerator);

/* eslint-disable import/prefer-default-export */
// memoize promise returning function so that it returns
// the same promise if called again before resolve / reject
function memoizePromise(callback) {
  var cache = {};

  function memoized() {
    for (var _len = arguments.length, parameters = new Array(_len), _key = 0; _key < _len; _key++) {
      parameters[_key] = arguments[_key];
    }

    var cacheKey = JSON.stringify(parameters);
    var cacheValue = cache[cacheKey];

    if (cacheValue) {
      return cacheValue;
    } // Get and add the value to the cache


    var value = callback.apply(this, parameters);
    cache[cacheKey] = value;

    if (!value || typeof value.then !== 'function') {
      throw new Error('Memoization Error, Async function returned non-promise value');
    } // Delete the value regardless of whether it resolves or rejects


    return value.then(function (internalValue) {
      cache[cacheKey] = false;
      return internalValue;
    }, function (err) {
      cache[cacheKey] = false;
      throw err;
    });
  }

  memoized.cache = cache;
  return memoized;
}

var ERROR_CONFIG_EMPTY = 'TokenGenerator config must be set';
var ERROR_CONFIG_PATH_SCHEME = 'TokenGenerator config is not valid, it should contain a "path", a "scheme" parameter';
var ERROR_CONFIG_CLIENT_INFORMATIONS = 'TokenGenerator config is not valid, it should contain a "clientId", a "clientSecret" parameter';

var ClientCredentialsGenerator = /*#__PURE__*/function (_AbstractTokenGenerat) {
  _inherits(ClientCredentialsGenerator, _AbstractTokenGenerat);

  var _super = _createSuper(ClientCredentialsGenerator);

  function ClientCredentialsGenerator(tokenGeneratorConfig) {
    var _this;

    _classCallCheck(this, ClientCredentialsGenerator);

    _this = _super.call(this, tokenGeneratorConfig);
    _this.generateToken = memoizePromise(_this.generateToken);
    return _this;
  }

  _createClass(ClientCredentialsGenerator, [{
    key: "generateToken",
    value: function generateToken() {
      var baseParameters = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var body = new URLSearchParams({
        grant_type: 'client_credentials',
        client_id: this.tokenGeneratorConfig.clientId,
        client_secret: this.tokenGeneratorConfig.clientSecret
      });

      if (baseParameters.scope) {
        body.append('scope', baseParameters.scope);
      } else if (this.tokenGeneratorConfig.scope) {
        body.append('scope', this.tokenGeneratorConfig.scope);
      }

      var params = {
        method: 'POST',
        headers: {
          'Content-Type': 'application/x-www-form-urlencoded'
        },
        body: body.toString()
      };
      var url = this.generateUrlFromConfig(this.tokenGeneratorConfig);

      if (this.logger) {
        this.logger.logRequest(_objectSpread2({
          url: url
        }, params));
      }

      return fetch(url, params);
    }
  }, {
    key: "refreshToken",
    value: function refreshToken( // eslint-disable-next-line @typescript-eslint/no-unused-vars
    accessToken) {
      return this.generateToken({});
    }
  }, {
    key: "checkTokenGeneratorConfig",
    value: function checkTokenGeneratorConfig(config) {
      if (!config || Object.keys(config).length === 0) {
        throw new RangeError(ERROR_CONFIG_EMPTY);
      }

      if (!(config.path && config.scheme)) {
        throw new RangeError(ERROR_CONFIG_PATH_SCHEME);
      }

      if (!(config.clientId && config.clientSecret)) {
        throw new RangeError(ERROR_CONFIG_CLIENT_INFORMATIONS);
      }
    }
  }]);

  return ClientCredentialsGenerator;
}(AbstractTokenGenerator);

var ERROR_CONFIG_EMPTY$1 = 'TokenGenerator config must be set';
var ERROR_CONFIG_PATH_SCHEME$1 = 'TokenGenerator config is not valid, it should contain a "path", a "scheme" parameter';
var ERROR_CONFIG_CLIENT_INFORMATIONS$1 = 'TokenGenerator config is not valid, it should contain a "clientId", a "clientSecret" parameter';
var ERROR_TOKEN_EMPTY = 'parameters must be set';
var ERROR_TOKEN_USERNAME_PASSWORD = 'username and password must be passed as parameters';

var PasswordGenerator = /*#__PURE__*/function (_AbstractTokenGenerat) {
  _inherits(PasswordGenerator, _AbstractTokenGenerat);

  var _super = _createSuper(PasswordGenerator);

  function PasswordGenerator() {
    _classCallCheck(this, PasswordGenerator);

    return _super.apply(this, arguments);
  }

  _createClass(PasswordGenerator, [{
    key: "generateToken",
    value: function generateToken(baseParameters) {
      this._checkGenerateParameters(baseParameters);

      var body = new URLSearchParams({
        grant_type: 'password',
        username: baseParameters.username,
        password: baseParameters.password,
        client_id: this.tokenGeneratorConfig.clientId,
        client_secret: this.tokenGeneratorConfig.clientSecret
      });

      if (baseParameters.scope) {
        body.append('scope', baseParameters.scope);
      } else if (this.tokenGeneratorConfig.scope) {
        body.append('scope', this.tokenGeneratorConfig.scope);
      }

      var url = this.generateUrlFromConfig(this.tokenGeneratorConfig);
      var params = {
        method: 'POST',
        headers: {
          'Content-Type': 'application/x-www-form-urlencoded'
        },
        body: body.toString()
      };

      if (this.logger) {
        this.logger.logRequest(_objectSpread2({
          url: url
        }, params));
      }

      return fetch(url, params);
    }
  }, {
    key: "refreshToken",
    value: function refreshToken(accessToken) {
      var refreshToken = accessToken === null || accessToken === void 0 ? void 0 : accessToken.refresh_token;

      if (!refreshToken) {
        throw new Error('refresh_token is not set. Did you called `generateToken` before ?');
      }

      var body = new URLSearchParams({
        grant_type: 'refresh_token',
        client_id: this.tokenGeneratorConfig.clientId,
        client_secret: this.tokenGeneratorConfig.clientSecret,
        refresh_token: refreshToken
      });

      if (this.tokenGeneratorConfig.scope) {
        body.append('scope', this.tokenGeneratorConfig.scope);
      }

      var url = this.generateUrlFromConfig(this.tokenGeneratorConfig);
      var params = {
        method: 'POST',
        headers: {
          'Content-Type': 'application/x-www-form-urlencoded'
        },
        body: body.toString()
      };

      if (this.logger) {
        this.logger.logRequest(_objectSpread2({
          url: url
        }, params));
      }

      return fetch(url, params);
    }
  }, {
    key: "checkTokenGeneratorConfig",
    value: function checkTokenGeneratorConfig(config) {
      if (!config || Object.keys(config).length === 0) {
        throw new RangeError(ERROR_CONFIG_EMPTY$1);
      }

      if (!(config.path && config.scheme)) {
        throw new RangeError(ERROR_CONFIG_PATH_SCHEME$1);
      }

      if (!(config.clientId && config.clientSecret)) {
        throw new RangeError(ERROR_CONFIG_CLIENT_INFORMATIONS$1);
      }
    }
  }, {
    key: "_checkGenerateParameters",
    value: function _checkGenerateParameters(parameters) {
      if (!(parameters && Object.keys(parameters).length > 0)) {
        throw new RangeError(ERROR_TOKEN_EMPTY);
      }

      if (!(parameters.username && parameters.password)) {
        throw new RangeError(ERROR_TOKEN_USERNAME_PASSWORD);
      }
    }
  }]);

  return PasswordGenerator;
}(AbstractTokenGenerator);

var _token = new WeakMap();

var _refreshTokenFunc = new WeakMap();

/* eslint-disable camelcase */

/**
 * @deprecated ProvidedTokenGenerator is not an Oauth valid generator.
 * You should use one of the official generator or implement your own custom generator.
 */
var ProvidedTokenGenerator = /*#__PURE__*/function () {
  function ProvidedTokenGenerator(token) {
    var refreshTokenFunc = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

    _classCallCheck(this, ProvidedTokenGenerator);

    _token.set(this, {
      writable: true,
      value: void 0
    });

    _refreshTokenFunc.set(this, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldSet(this, _token, token);

    _classPrivateFieldSet(this, _refreshTokenFunc, refreshTokenFunc);
  }

  _createClass(ProvidedTokenGenerator, [{
    key: "generateToken",
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    value: function generateToken() {
      return Promise.resolve(_classPrivateFieldGet(this, _token));
    } // eslint-disable-next-line @typescript-eslint/no-unused-vars

  }, {
    key: "refreshToken",
    value: function refreshToken(accessToken) {
      if (typeof _classPrivateFieldGet(this, _refreshTokenFunc) === 'function') {
        return _classPrivateFieldGet(this, _refreshTokenFunc).call(this, accessToken);
      }

      return this.generateToken();
    }
  }, {
    key: "autoGenerateToken",
    value: function autoGenerateToken() {
      return this.generateToken();
    }
  }, {
    key: "token",
    set: function set(token) {
      _classPrivateFieldSet(this, _token, token);
    }
  }]);

  return ProvidedTokenGenerator;
}();

// eslint-disable-next-line @typescript-eslint/no-explicit-any
function isResponse(response) {
  return typeof (response === null || response === void 0 ? void 0 : response.json) === 'function';
}

function manageOauthError(body, response) {
  var error;

  if (response) {
    error = getHttpErrorFromResponse(response);
  }

  if (body.error === 'invalid_grant') {
    throw new InvalidGrantError(body.error, error);
  }

  if (body.error === 'invalid_scope') {
    throw new InvalidScopeError(body.error, error);
  }

  throw new OauthError(body.error, error);
}

var _tokenGenerator = new WeakMap();

var _hasATokenBeenGenerated = new WeakMap();

var _asyncStorage = new WeakMap();

var _logger = new WeakMap();

var TokenStorage = /*#__PURE__*/function () {
  function TokenStorage(tokenGenerator, asyncStorage) {
    var accessTokenKey = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'rest_client_sdk.api.access_token';
    var logger = arguments.length > 3 ? arguments[3] : undefined;

    _classCallCheck(this, TokenStorage);

    _tokenGenerator.set(this, {
      writable: true,
      value: void 0
    });

    _hasATokenBeenGenerated.set(this, {
      writable: true,
      value: void 0
    });

    _defineProperty(this, "accessTokenKey", void 0);

    _asyncStorage.set(this, {
      writable: true,
      value: void 0
    });

    _logger.set(this, {
      writable: true,
      value: void 0
    });

    if (logger) {
      _classPrivateFieldSet(this, _logger, logger);
    }

    _classPrivateFieldSet(this, _tokenGenerator, tokenGenerator);

    _classPrivateFieldSet(this, _hasATokenBeenGenerated, false);

    this.setAsyncStorage(asyncStorage);
    this.accessTokenKey = accessTokenKey;
    this.handleTokenResponse = this.handleTokenResponse.bind(this);
    this.generateToken = memoizePromise(this.generateToken);
    this.refreshToken = memoizePromise(this.refreshToken);
  }

  _createClass(TokenStorage, [{
    key: "setAsyncStorage",
    value: function setAsyncStorage(asyncStorage) {
      _classPrivateFieldSet(this, _asyncStorage, asyncStorage);
    }
  }, {
    key: "hasAccessToken",
    value: function hasAccessToken() {
      return _classPrivateFieldGet(this, _asyncStorage).getItem(this.accessTokenKey).then(function (accessToken) {
        return !!accessToken;
      });
    }
  }, {
    key: "getAccessToken",
    value: function getAccessToken() {
      return this.getAccessTokenObject().then(function (token) {
        return token && token.access_token;
      });
    }
  }, {
    key: "getAccessTokenObject",
    value: function getAccessTokenObject() {
      var _this = this;

      return _classPrivateFieldGet(this, _asyncStorage).getItem(this.accessTokenKey).then(function (token) {
        if (token) {
          var tokenObject = JSON.parse(token);

          if (_typeof(tokenObject) !== 'object') {
            return null;
          }

          return tokenObject;
        }

        if (_classPrivateFieldGet(_this, _hasATokenBeenGenerated)) {
          return null;
        }

        if (typeof _classPrivateFieldGet(_this, _tokenGenerator).autoGenerateToken === 'function') {
          return _classPrivateFieldGet(_this, _tokenGenerator).autoGenerateToken();
        }

        throw new Error('No token has been generated yet.');
      });
    }
  }, {
    key: "logout",
    value: function logout() {
      return _classPrivateFieldGet(this, _asyncStorage).removeItem(this.accessTokenKey);
    }
  }, {
    key: "_addExpiresAtToResponseData",
    value: function _addExpiresAtToResponseData(responseData, callTimestamp) {
      if (!responseData) {
        return responseData;
      }

      var updatedResponseData = _objectSpread2(_objectSpread2({}, responseData), {}, {
        expires_at: null
      });

      if (typeof updatedResponseData.expires_in !== 'undefined' && updatedResponseData.expires_in !== null // && updatedResponseData.expires_in >= 0
      ) {
          updatedResponseData.expires_at = Math.round(callTimestamp / 1000) + updatedResponseData.expires_in;
        }

      return updatedResponseData;
    }
  }, {
    key: "generateToken",
    value: function generateToken(parameters) {
      var _this2 = this;

      var callTimestamp = Date.now();
      return _classPrivateFieldGet(this, _tokenGenerator).generateToken(parameters).then(this.handleTokenResponse).then(function (body) {
        var updatedResponseData = _this2._addExpiresAtToResponseData(body, callTimestamp);

        return _this2._storeAccessToken(updatedResponseData).then(function () {
          _classPrivateFieldSet(_this2, _hasATokenBeenGenerated, true);

          return updatedResponseData;
        });
      });
    }
  }, {
    key: "refreshToken",
    value: function refreshToken() {
      var _this3 = this;

      return _classPrivateFieldGet(this, _asyncStorage).getItem(this.accessTokenKey).then(function (token) {
        var callTimestamp = Date.now();
        return _classPrivateFieldGet(_this3, _tokenGenerator).refreshToken(token ? JSON.parse(token) : null).then(_this3.handleTokenResponse).then(function (body) {
          var updatedResponseData = _this3._addExpiresAtToResponseData(body, callTimestamp);

          return _this3._storeAccessToken(updatedResponseData).then(function () {
            return updatedResponseData;
          });
        });
      });
    }
  }, {
    key: "handleTokenResponse",
    value: function handleTokenResponse(responseOrBody) {
      if (isResponse(responseOrBody)) {
        var response = responseOrBody;
        var originalResponse = response.clone();

        if (_classPrivateFieldGet(this, _logger)) {
          _classPrivateFieldGet(this, _logger).logResponse(response);
        }

        return response.json().then(function (body) {
          if (isOauthError(body)) {
            // throw error if response body is an oauth error
            manageOauthError(body, originalResponse);
          } else if (response.status >= 400) {
            // throw an error if response status code is an "error" status code
            throw getHttpErrorFromResponse(originalResponse);
          }

          return body;
        })["catch"](function (err) {
          if (!(err instanceof OauthError)) {
            throw new OauthError(err.type, getHttpErrorFromResponse(originalResponse));
          }

          throw err;
        });
      }

      var body = responseOrBody;

      if (isOauthError(body)) {
        // throw error if response body is an oauth error
        manageOauthError(body);
      }

      return Promise.resolve(body);
    }
    /**
     * Return the number of second when the token will expire
     * return value can be negative if the token is already expired
     */

  }, {
    key: "getCurrentTokenExpiresIn",
    value: function getCurrentTokenExpiresIn() {
      return this.getAccessTokenObject().then(function (accessTokenObject) {
        if (accessTokenObject === null) {
          throw new Error('No token has been stored.');
        }

        if (typeof accessTokenObject.expires_at === 'undefined' || accessTokenObject.expires_at === null) {
          return null;
        }

        var now = Math.round(Date.now() / 1000);
        return accessTokenObject.expires_at - now;
      });
    }
  }, {
    key: "_storeAccessToken",
    value: function _storeAccessToken(responseData) {
      return _classPrivateFieldGet(this, _asyncStorage).setItem(this.accessTokenKey, JSON.stringify(responseData));
    }
  }]);

  return TokenStorage;
}();

export default RestClientSdk;
export { AbstractClient, AbstractTokenGenerator, Attribute, AuthorizationCodeFlowTokenGenerator, BadRequestError, ClassMetadata, ClientCredentialsGenerator, ConflictError, ForbiddenError, HttpError, InternalServerError, InvalidGrantError, InvalidScopeError, Logger, Mapping, OauthError, PasswordGenerator, ProvidedTokenGenerator, Relation, ResourceNotFoundError, Serializer, TokenStorage, UnauthorizedError };
//# sourceMappingURL=index.mjs.map
