import AbstractTokenGenerator from './AbstractTokenGenerator';
import { Token, TokenResponse } from './types';
declare type Config = {
    clientId: string;
    clientSecret: string;
    path: string;
    scheme: string;
    port?: string;
    scope?: string;
};
declare type GenerateTokenParameters = {
    username: string;
    password: string;
    scope?: string;
};
interface PasswordToken extends Token {
    access_token: string;
    token_type: string;
    refresh_token?: string;
    expires_in?: number;
    scope?: string;
}
declare type PasswordTokenResponse = TokenResponse<PasswordToken>;
declare class PasswordGenerator extends AbstractTokenGenerator<PasswordToken, Config> {
    generateToken(baseParameters: GenerateTokenParameters): Promise<PasswordTokenResponse>;
    refreshToken(accessToken: null | PasswordToken): Promise<PasswordTokenResponse>;
    checkTokenGeneratorConfig(config: Config): void;
    _checkGenerateParameters(parameters: GenerateTokenParameters): void;
}
export default PasswordGenerator;
