import TokenGeneratorInterface from './TokenGeneratorInterface';
import { Token } from './types';
declare type RefreshTokenFunc = (oldAccessToken: null | Token) => Promise<Token>;
/**
 * @deprecated ProvidedTokenGenerator is not an Oauth valid generator.
 * You should use one of the official generator or implement your own custom generator.
 */
declare class ProvidedTokenGenerator implements TokenGeneratorInterface<Token> {
    #private;
    constructor(token: Token, refreshTokenFunc?: null | RefreshTokenFunc);
    set token(token: Token);
    generateToken(): Promise<Token>;
    refreshToken(accessToken: null | Token): Promise<Token>;
    autoGenerateToken(): Promise<Token>;
}
export default ProvidedTokenGenerator;
