declare type SdkRequest = RequestInit & {
    url: string;
};
declare type SdkResponse = {
    status: number;
    headers: Record<string, string>;
};
export declare type SerializableRequest = {
    url: string;
    method?: string;
    headers?: Record<string, string>;
    body?: string;
};
export declare type Log = {
    id: string;
    request?: SerializableRequest;
    response?: SdkResponse;
    logTimes: {
        request?: number;
        response?: number;
    };
};
export declare type LoggerHistory = Array<Log>;
export declare class Logger {
    #private;
    get history(): LoggerHistory;
    constructor();
    logRequest(params: SdkRequest): string;
    logResponse(response: Response, requestId?: undefined | string): string;
}
export {};
